#include "mex.h"
#include <math.h>

void mexFunction (int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[])
{
    
    double *x, *y;
    double sigma;

    mwSize len, i;
    double sumSqr, retVal;

    if (nrhs != 3)
    {
        mexErrMsgIdAndTxt( "MATLAB:gauss_kernel:incorrectInputArguments",
                           "Cannot specify more or less than 3 inputs.\n");
    }

    if (nlhs != 1)
    {
        mexErrMsgIdAndTxt("MATLAB:gauss_kernel:incorrectOutputArguments", 
                          "Cannot specify more or less than 1 input.\n");
    }

    x     = mxGetPr(prhs[0]);
    y     = mxGetPr(prhs[1]);
    sigma = mxGetScalar(prhs[2]); 
    
    len = mxGetM(prhs[0]);
    /*printf("len: %d\n", len);*/

    sumSqr = 0.0;
    for (i = 0; i < len; i++)
    {
        sumSqr = sumSqr + ((x[i]-y[i]) *(x[i]-y[i]));
    }
    retVal = exp(-sigma*sumSqr);

    plhs[0] = mxCreateDoubleScalar(retVal);

    return;
}
