#include "mex.h"
#include <math.h>

void mexFunction (int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[])
{
    
    double *x, *y;
    double degree, bias;

    mwSize len, i;
    double sum, retVal;

    if (nrhs != 4)
    {
        mexErrMsgIdAndTxt( "MATLAB:gauss_kernel:incorrectInputArguments",
                           "Cannot specify more or less than 4 inputs.\n");
    }

    if (nlhs != 1)
    {
        mexErrMsgIdAndTxt("MATLAB:gauss_kernel:incorrectOutputArguments", 
                          "Cannot specify more or less than 1 input.\n");
    }

    x      = mxGetPr(prhs[0]);
    y      = mxGetPr(prhs[1]);
    degree = mxGetScalar(prhs[2]); 
    bias   = mxGetScalar(prhs[3]); 
    
    len = mxGetM(prhs[0]);
    /*printf("len: %d\n", len);*/

    sum = 0.0;
    for (i = 0; i < len; i++)
    {
        sum = sum + (x[i] * y[i]);
        if (bias)
        {
            sum = sum + 1.0;
        }
    }
    retVal = pow(sum, degree);

    plhs[0] = mxCreateDoubleScalar(retVal);

    return;
}
